Name:           guacamole-client
Version:        0.8.3
Release:        4%{?dist}
Summary:        Server-side Java components that form the Guacamole application

License:        MPLv1.1 or GPL+ or AGPLv3+
URL:            http://guac-dev.org/
Source0:        http://guac-dev.org/pub/dist/source/%{name}-%{version}.tar.gz

Patch0:         %{name}-0.8.3-allow-linking.patch
BuildArch:      noarch

BuildRequires:  java-devel
BuildRequires:  maven-clean-plugin
BuildRequires:  maven-dependency-plugin
BuildRequires:  maven-local
BuildRequires:  maven-release-plugin
BuildRequires:  maven-war-plugin
BuildRequires:  servlet3

%description
Guacamole is an HTML5 remote desktop gateway.

Guacamole provides access to desktop environments using remote desktop protocols
like VNC and RDP. A centralized server acts as a tunnel and proxy, allowing
access to multiple desktops through a web browser.

No browser plugins are needed, and no client software needs to be installed. The
client requires nothing more than a web browser supporting HTML5 and AJAX.

The centralized server is provided by the "guacamole-server" package.

%package -n guacamole
Summary:        Web-based remote desktop application
Requires:       apache-commons-logging
Requires:       java
Requires:       jpackage-utils
Requires:       slf4j >= 1.6.1
Requires:       tomcat
Requires:       tomcat-native
Obsoletes:      guacamole-common < 0.8.2
Obsoletes:      guacamole-common-js < 0.8.2
Obsoletes:      guacamole-ext < 0.8.2
Provides:       guacamole-common = %{version}-%{release}
Provides:       guacamole-common-js = %{version}-%{release}
Provides:       guacamole-ext = %{version}-%{release}

%description -n guacamole
This package contains the main HTML5 web application for the Guacamole stack
that provides access to desktop environments using remote desktop protocols such
as VNC or RDP.

A centralized server acts as a tunnel and proxy, allowing access to multiple
desktops through a web browser. No plugins are needed: the client requires
nothing more than a web browser supporting HTML5 and AJAX.

The centralized server is provided by the "guacd" package and its associated
"libguac-client-*" packages.

%package -n guacamole-javadoc
Summary:        API documentation for %{name}
Obsoletes:      guacamole-common-javadoc < 0.8.2
Obsoletes:      guacamole-ext-javadoc < 0.8.2
Provides:       guacamole-common-javadoc = %{version}-%{release}
Provides:       guacamole-ext-javadoc = %{version}-%{release}

%description -n guacamole-javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1

%build
mvn-rpmbuild package javadoc:aggregate

%install
# Put data files into tomcat's webapps directory
mkdir -p %{buildroot}%{_datadir}/tomcat/webapps/guacamole/
cp -frp guacamole/target/guacamole-%{version}/* %{buildroot}%{_datadir}/tomcat/webapps/guacamole/

# Use Fedora packaged jar files
find %{buildroot}%{_datadir}/tomcat/webapps/guacamole/WEB-INF/lib/*jar ! -name "*guacamole*jar" -delete
for jar in commons-logging.jar slf4j/api.jar slf4j/jcl.jar; do
    ln -sf %{_javadir}/$jar %{buildroot}%{_datadir}/tomcat/webapps/guacamole/WEB-INF/lib/
done

# Configuration file
mkdir -p %{buildroot}%{_sysconfdir}/guacamole
cp -p guacamole/doc/example/* %{buildroot}%{_sysconfdir}/guacamole
sed -i -e 's@/path/to@%{_sysconfdir}/guacamole@g' %{buildroot}%{_sysconfdir}/guacamole/guacamole.properties
ln -sf %{_sysconfdir}/guacamole/guacamole.properties %{buildroot}%{_datadir}/tomcat/webapps/guacamole/WEB-INF/classes/

# Docs
mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -rp target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}/

%pretrans -n guacamole
# Workaround for rpm bug; replacing directory with symlink fails.
# Open since 2008!
# https://bugzilla.redhat.com/show_bug.cgi?id=975909
# https://bugzilla.redhat.com/show_bug.cgi?id=447156
if [ $1 = 0 ]; then
    [ -h %{_datadir}/tomcat/webapps/guacamole/guacamole-common-js ] && \
        rm -f %{_datadir}/tomcat/webapps/guacamole/guacamole-common-js
    exit 0
fi

%files -n guacamole
%doc guacamole/COPYING guacamole-ext/LICENSE guacamole/README
%{_datadir}/tomcat/webapps/guacamole
%dir %{_sysconfdir}/guacamole
%config(noreplace) %attr(640,root,tomcat) %{_sysconfdir}/guacamole/user-mapping.xml
%config(noreplace) %attr(640,root,tomcat) %{_sysconfdir}/guacamole/guacamole.properties

%files -n guacamole-javadoc
%doc guacamole/COPYING guacamole-ext/LICENSE
%{_javadocdir}/%{name}

%changelog
* Fri Oct 11 2013 Simone Caronni <negativo17@gmail.com> - 0.8.3-4
- Tighten permissions on user-mapping.xml.
- Fix slf4j symlinks (thanks Alexander Hoff).

* Mon Sep 23 2013 Simone Caronni <negativo17@gmail.com> - 0.8.3-3
- Rebuild with udpated source tarball.

* Tue Sep 10 2013 Simone Caronni <negativo17@gmail.com> - 0.8.3-2
- Change summary.

* Wed Aug 28 2013 Simone Caronni <negativo17@gmail.com> - 0.8.3-1
- Update to 0.8.3.
- Drop upstreamed patch.

* Sun Aug 04 2013 Simone Caronni <negativo17@gmail.com> - 0.8.2-3
- Add proper Obsolete / Provides for javadoc packages.

* Mon Jul 22 2013 Simone Caronni <negativo17@gmail.com> - 0.8.2-2
- Review fixes.

* Tue Jul 16 2013 Simone Caronni <negativo17@gmail.com> - 0.8.2-1
- First build.
